#ifndef ATOMS_DATA_H
#define ATOMS_DATA_H

#include "vec3.h"
#include "mat33.h"
#include "BOND_INFO.h"


class ATOMS_DATA {
public:
	int frame;	//読み込んだ順に0からインクリメント
	int no;
	int pcnt;
	int istep;
	float realtm;
	mat33d boxaxis;
	vec3d boxorg;
	float tempave;
	float tempvar;
	int* knd;
	int* id;
	vec3f* r;
	vec3f* p;
	char* info;		//主に文字列などに使用

	BOND_INFO bond;

	ATOMS_DATA() : 
		pcnt(0),
		knd(NULL),
		id(NULL),
		r(NULL),
		p(NULL),
		info(NULL)
		{	};

	virtual ~ATOMS_DATA(){
		delete [] this->knd;
		delete [] this->id;
		delete [] this->r;
		delete [] this->p;
		delete [] this->info;
	};

};


#endif    // !ATOMS_DATA