
#ifndef BoxRendererDX11_h
#define BoxRendererDX11_h

#pragma once
#include <d3d11.h>


#include "MDLoader.h"	//ATOMS_DATAのためだけに必要//
#include "BOND_INFO.h"

//#include "sdkwgl.h"
#include "vec3.h"
#include "mat33.h"
#include "mat44.h"
#include "io64.h"
#include "mod.h"


#include "visual.h"


#include "BasicRenderer.h"
#include "VertexTypes.h"




class BoxRendererDX11{
private:


	RendererWrapper renderer;

    VERTEX_F3UI1* m_vbo_vertex;
    int* m_vbo_indexes;


    HRESULT InitShader();
	//mat44f m_ViewMatrix;
	//mat44f m_ProjectionMatrix;

public:

    BoxRendererDX11(ID3D11Device* pD3DDevice, ID3D11DeviceContext* pD3DDeviceContext, CommonShader* comShader);
    virtual ~BoxRendererDX11();


    void Draw(mat33d& axis, vec3d& org, int size,  unsigned int color);


	void SetViewAndProjectionMatrix(const float* pViewMatrix, const float* pProjectionMatrix) {
		renderer.SetViewAndProjectionMatrix(pViewMatrix, pProjectionMatrix);		
	}
	
};




#endif

