//=====================================
// スクリプト用の3dxml_loader管理クラス
//
//
// 3dxmlを読み込み＆表示する
//
// 
//=====================================

#ifndef __field3dloader_h__
#define __field3dloader_h__



#pragma once

#include "targetver.h"
#include <windows.h>

#include <stdio.h>
#include <tchar.h>
#include <string.h>

#include "sdkwgl.h"

#include "vec3.h"
#include "mat33.h"
#include "IDataAtoms.h"

#include "debugprint.h"




class Field3DLoader : public IDataContainer{
private:
	
	struct FIELD3D_FRAME{
		//long64 filepos;
		GLubyte* fieldb;
		int grid_x;//グリッド数
		int grid_y;
		int grid_z;
		mat33d boxaxis;
		vec3d boxorg;
	};

	FIELD3D_FRAME* m_frames;
	int m_frame_count;
	int m_frame_index;
	
	
	//bool m_created_tex;

	//GLuint m_textureName;
	
	
	template<typename T> GLubyte* TransformToByteColor(T* field, int mesh_sz, T maxvalue);
	void SpectrumColor(double value, BYTE *r, BYTE* g, BYTE * b);
	void valueToRGBA(double value, double maxValue, unsigned char *rgb);

	float* LoadCube(const TCHAR* filename, float* pmaxvalue, FIELD3D_FRAME* frame);
	
public:
	
	Field3DLoader();
	virtual ~Field3DLoader();
	
	int Load(const TCHAR* filename);
	

	void GetBoxaxis(mat33d* boxaxis, vec3d* boxorg){
		*boxaxis = m_frames[m_frame_index].boxaxis;
		*boxorg = m_frames[m_frame_index].boxorg;
		
	};

	void GetGridSize(int* pgridx, int* pgridy, int* pgridz ){
		*pgridx = m_frames[m_frame_index].grid_x;
		*pgridy = m_frames[m_frame_index].grid_y;
		*pgridz = m_frames[m_frame_index].grid_z;
	};
	
	GLubyte* GetDataPointer( ){
		return m_frames[m_frame_index].fieldb;
	};
	
	int SetFrameNum(int timeframe);
	
};


#endif    // __field3dloader_h__


