//=====================================
// 複数インスタンス表示クラス
//
//
// 
//=====================================
#pragma once

#ifndef KrbRendererDX11_h
#define KrbRendererDX11_h

#include <d3d11.h>
#include <unordered_map>



#include "MDLoader.h"	//ATOMS_DATAのためだけに必要//
#include "BOND_INFO.h"

//#include "sdkwgl.h"
#include "vec3.h"
#include "mat33.h"
#include "mat44.h"
#include "io64.h"
#include "mod.h"


#include "visual.h"
#include "krb_reader.h"


#include "BasicRenderer.h"
#include "VertexTypes.h"
#include "GeometrySphere.h"
#include "GeometryCylinder.h"







class KrbRendererDX11{
private:

	RendererWrapper renderer;

	void InitShader();	

	int m_vram_size;
	int m_vbo_vcount;
	VERTEX_F3F3UI1* m_vbo_vertex;
	int m_vbo_icount;
	int* m_vbo_indexes;
	unsigned int m_index_type;

	//unsigned int *m_color_table;	//原子ごとの色が入る

    KRB_INFO m_prev_krb_info;	//前回レンダリングしたデータ

    int CreateBond(int i_begin, int i_end, int limit_v_count, int limit_i_count, KRB_INFO* dat, uint32_t trajectory_color, int lower_visual_frame);
    int CreateSphere(int limit_v_count, int limit_i_count);
	

//ポリゴンモデル用のバッファ
	
	GeometrySphere* m_geometry_sphere;
	GeometryCylinder* m_geometry_bond;
	


	struct DRAWN_PARTICLE {
		vec3f position;
		unsigned int color_table;
	};
	std::unordered_map<size_t, DRAWN_PARTICLE> m_particles;

	VISUAL_SETTING m_prev_vis;

	int m_visual_bond;	//ボンドの表示種類
	


public:
	KrbRendererDX11(ID3D11Device* pD3DDevice, ID3D11DeviceContext* pD3DDeviceContext, CommonShader* comShader);
    virtual ~KrbRendererDX11();

    void Draw(KRB_INFO* dat, uint32_t trajectory_color, const VISUAL_SETTING& vis);

	void SetViewAndProjectionMatrix(const float* pViewMatrix, const float* pProjectionMatrix) {
		renderer.SetViewAndProjectionMatrix(pViewMatrix, pProjectionMatrix);
	}
};


#endif    // __AtomRendererDX11_h__


