// PointRendererDX11.h: PointRendererDX11 クラスのインターフェイス
//
//////////////////////////////////////////////////////////////////////

#ifndef PointSpriteDX11_H
#define PointSpriteDX11_H

#pragma once

#include <d3d11.h>

#include "MDLoader.h"	//ATOMS_DATAのためだけに必要//
#include "BOND_INFO.h"

//#include "sdkwgl.h"
#include "vec3.h"
#include "mat33.h"
#include "mat44.h"
#include "io64.h"
#include "mod.h"


#include "visual.h"
#include "BasicRenderer.h"

#include "PointRendererDX11.h"

class PointSpriteDX11 : public BasePointRendererDX11{
private:

    
    struct mVERTEX {
    vec3f position;
    float color[4];
    };
    


private:




    int m_vram_size;
    int m_vbo_vcount;
    mVERTEX* m_vbo_vertex;

    

    float* m_prev_render_dat;	//前回レンダリングしたデータ
    
    void CreateSphere(int start, int count, int stride, float* values, const float* range_max, const float* range_min, float alpha);

public:

    PointSpriteDX11(ID3D11Device* pD3DDevice, ID3D11DeviceContext* pD3DDeviceContext, CommonShader* comShader);
    virtual ~PointSpriteDX11();


    void Draw(float* values, const int count, const int stride, const float* range_max, const float* range_min, float alpha);


};




#endif


