#pragma once

#ifndef UICamera_H
#define UICamera_H


#include "camera.h"



class UICamera
{
private:


	CameraGL m_camera;


	//mouse operation//
	int m_mouse_toggle;
	POINT m_mouse_toggle_ctr;

	
	
public:

	UICamera();
	virtual ~UICamera();

	/*
	変換行列の取得
	*/
	void GetViewMatrix(double* view_matrix);

	/*
	焦点距離の取得
	*/
	double GetFocusDistance();


	void ResetFocus(const double focus_distance, const vec3d& target_position){
		m_camera.ResetFocus(focus_distance, target_position);
	}



	/*
		スクリーン上の点がカメラから見てどの方向になっているかを返す
	*/
	void GetRAY(double x, double y, double w, double h, vec3d* vray, vec3d* vorg){
		m_camera.GetRAY(x, y, w, h, vray, vorg);
	}
	

	//カメラ操作系////////////////////////////////////////////////
	int MouseDownTrans(int x, int y);
	//int MouseUpTrans();
	int MouseMoveTrans(int x, int y, int w, int h);
	int MouseDownRot(int x, int y);
	//int MouseUpRot();
	int MouseMoveRot(int x, int y, int w, int h);
	int ZoomIn(double d);

	int TranslateUp(double d){
		m_camera.TargetMoveToUp(d);
		return 1;
	};

	int TranslateLeft(double d){
		m_camera.TargetMoveToSide(d);
		return 1;
	};

	int RotateOnUpAxis(double rad){
		m_camera.RotatePosOnUpAxis(rad);
		return 1;
	};

	int RotateOnLeftAxis(double rad){
		m_camera.RotatePosToUp(rad);
		return 1;
	};

	/*
	int SetYawPitchRoll(double yaw, double pitch, double roll){
		m_camera.SetYawPitchRoll(yaw, pitch, roll);
		return 1;
	};
	*/

	int SetRotationMatrix(const float* matrix){
		m_camera.SetRotationMatrix(matrix);
		return 1;
	};

	//cross section//
	void SetCrosssection(int section, int sprit){
		m_camera.SetViewFront(section, sprit);
	};

	void ResetCrosssection(){
		m_camera.ResetViewFront();
	};
	////////////////////////////////////////////////カメラ操作系//


    void SetPosition(vec3d& camera, vec3d& target, vec3d& up){
        m_camera.SetPosition(camera, target, up);
    }


};

#endif