
#ifndef __VNTRenderer_h__
#define __VNTRenderer_h__


#pragma once


#include <stdio.h>
#include <tchar.h>
#include <string.h>
#include <math.h>


#include "vec4.h"
#include "BasicRenderer.h"
#include "material_info.h"

#include "TextureManagerDX11.h"



class VNTRenderer : public BasicRenderer{
protected:


//DX11 shader---------------------------------------
	
	ID3D11VertexShader* m_pVertexShaderTex;
	ID3D11PixelShader* m_pPixelShaderTex;

	ID3D11Buffer* m_pColorBuffer;
	

	ID3D11ShaderResourceView*	m_pTextureRVArray;
	ID3D11SamplerState*     m_pSampler;

    TextureManager m_texture_managrer;
	
	StateManagerDX11 m_state_manager;

	HRESULT InitShader();
public:
	
	VNTRenderer(ID3D11Device* pD3DDevice, ID3D11DeviceContext* pD3DDeviceContext, CommonShader* comShader);
	virtual ~VNTRenderer();

	
	virtual void DrawMaterials(int material_count, MATERIAL_INFO* materials, mat44f* pworld_matrix);
	void DrawMaterials(int material_count, MATERIAL_INFO* materials, vec3f* position);//ラッパー

};



#endif    // __VNTRenderer_h__

